/*
UDP Client
*/
#include<stdio.h> 		
//printf
#include<string.h> 		
//memset
#include<stdlib.h> 		
//exit(0);
#include<arpa/inet.h>
#include<sys/socket.h>
#define SERVER "192.168.1.201"	
//Serveradresse
#define BUFLEN 1024		
//Bufferlaenge
#define PORT 8888   	
//Sendeport
void die(char *s)	
//Wenn ein Systemaufruf fehlschlaegt erscheint eine 
//Fehlermeldung und das Programm wird abgebrochen 
{
perror(s);
exit(1);
}

/*------------------Hauptprogramm------------------------*/
int main(void)																												
{
struct sockaddr_in AdressStorage;																		
//Variable AdressStorage der Struktur sockaddr_in beinhaltet 
//verschiedene Komponenten zum Speichern von Adressen
int s, i, slen=sizeof(AdressStorage);
char buf[BUFLEN];
char message[BUFLEN];
if ( (s=socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP)) == -1)												
{																	

die("socket");																						
}//UDP Socket erstellen. Wenn Rueckgabewert der Funktion socket -1 ist, ist die Kommunikationsverbindung fehlgeschlagen
	
//SOCK_DGRAM gibt an, dass UDP Sockets verwendet werden fuer TCP Sockets wird SOCK_STREAM verwendet

memset((char *) &AdressStorage, 0, sizeof(AdressStorage));												
//Beschreibt den kompletten Speicherbereich der Variablen 
//AdressStorage mit Nullen
AdressStorage.sin_family = AF_INET;																		
//Adressfamilie des Netzwerk wird auf "Internet" gesetzt, auf IPv4. Fuer IPv6 muss AF_INET6 eingegeben werden
AdressStorage.sin_port = htons(PORT);																	
//Konvertierung und Deklaration der Portnummer

if (inet_aton(SERVER , &AdressStorage.sin_addr) == 0)													
 
{
fprintf(stderr, "inet_aton() fehlgeschlagen\n");
exit(1);
}//inet_aton liefert eine Null falls die IP Adresse keine Valide Adresse ist	

while(1)																								
//Sendedauerschleife
{
printf("Message eingeben : ");
bzero(buf,BUFLEN);//Befuellt den Buffer mit Nullen
fgets(message,(BUFLEN-1),stdin);//Schreibt die Standarteingabe stdin in das Array message

if (sendto(s, message, strlen(message) , 0 , (struct sockaddr *) &AdressStorage, slen)==-1)			
{																									
die("sendto()");
}//Message ueber Netzwerk versenden. Sendto liefert -1 zurueck wenn Uebertragung fehlgeschlagen ist

memset(buf, '\0', BUFLEN);
//Befuellt Speicherbereich von Buffer mit Nullen

/*----------------------------------------------------------------*/ //Falls keine Daten vom Server zurueckgesendet werden kann dieser Block auskommentiert werden. 
      
if (recvfrom(s, buf, BUFLEN, 0, (struct sockaddr *) &AdressStorage, &slen) == -1)					
				
{																									
die("recvfrom()");
}

puts(buf);																							
//Falls Daten zurueck kommen werden diese im Terminal Ausgegeben
/*----------------------------------------------------------------*/		
}

close(s);
return 0;
}